/*
 * Copyright (C) 2015 by Multi-Tech Systems
 *
 * This file is part of libmts.
 *
 * libmts is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * libmts is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with libmts.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

/*! \file   MTS_BasicPublisher.h
 \brief  A simple publisher
 \date   28MAR12
 \author Sean Godinez

 A basic publisher.
 */

#ifndef _MTS_BASICPUBLISHER_H_
#define _MTS_BASICPUBLISHER_H_

#include <mts/MTS_Publisher.h>

namespace MTS {

    //! A basic publisher
    /*!
     A basic publisher provides simple publishing functionality.

     \sa Publisher, Subscriber, BasicSubscriber
     */
    template<class T> class BasicPublisher: public Publisher<T> {

        public:
            BasicPublisher();                           //!< Constructor
            virtual ~BasicPublisher();                  //!< Destructor

            virtual void publish(const T& object); //!< Publishes T to Subscribers
    };

    template<class T> BasicPublisher<T>::BasicPublisher() {
    }

    template<class T> BasicPublisher<T>::~BasicPublisher() {
    }

    template<class T> void BasicPublisher<T>::publish(const T& object) {
        Publisher<T>::publish(object);
    }

}

#endif
